<?php
error_reporting(E_ALL ^ E_DEPRECATED);
?>
<html>
  <head>
    <title>My2 - Current Status</title>
    <link rel="stylesheet" href="gc.css" />
    <link rel="icon" href="DBguru.png" />
    <script type="text/javascript" src="https://www.google.com/jsapi"></script>

<?php date_default_timezone_set('UTC'); echo '<!Time (UTC): '. date('Y-m-d G:i:s.u') .">\n";
if ( ! file_exists('config.inc.php')) {
    echo '<h1>Configuration file missing</h1>';
    echo '<p>Please create <b>config.inc.php</b> configuration file';
    echo '<p>See the <b><a href="faq.htm#Con_00">online documentation</a></b> for more information.';
    exit;
}
include 'common.php';
if (isset($_GET['my2Conn']))
     $_SESSION['my2Conn'] = $_GET['my2Conn'];
else $_SESSION['my2Conn'] = 1;
$my2c = $_SESSION['my2Conn'];
$cnn = mysqli_connect($my2conn["host"][$my2c], $my2conn["user"][$my2c], $my2conn["pass"][$my2c]);
if ( ! $cnn ) {
    echo '<h1>Connection error</h1>';
    echo '<p>Please check Your <b>config.inc.php</b> configuration file';
    exit; };
?>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('number', 'ID'); data.addColumn('string', 'User'); data.addColumn('string', 'Host');
        data.addColumn('string', 'DB');
        data.addColumn('string', 'Command');
        data.addColumn('number', 'Time');
        data.addColumn('string', 'State');
        data.addColumn('string', 'Info');
        data.addRows(100);
<?php
$sql = "SELECT id, user, host, db, command, time, state, info FROM information_schema.processlist ORDER BY state desc, time LIMIT 100";
$result = mysqli_query($cnn, $sql);
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,".$record['id'].");";
   echo "data.setCell(".$i.",1,'".$record['user']."');";
   echo "data.setCell(".$i.",2,'".$record['host']."');";
   echo "data.setCell(".$i.",3,'".$record['db']."');";
   echo "data.setCell(".$i.",4,'".$record['command']."');";
   echo "data.setCell(".$i.",5,".$record['time'].");";
   echo "data.setCell(".$i.",6,'".$record['state']."');";
   echo "data.setCell(".$i.",7,'".str_replace("\r"," ",str_replace("\n"," ",addslashes(substr($record['info'],0,1024))))."');\n";
   $i=$i+1;
   }
?>
        var table = new google.visualization.Table(document.getElementById('queryProcessList'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 10, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Host Connections');
        data.addColumn('number', 'Current');
        data.addColumn('number', 'Total');
        data.addRows(50);
<?php
$sql = "select host, current_connections curr, total_connections tot from performance_schema.hosts
 order by curr desc, tot desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
    $i=0; while ($record = mysqli_fetch_array($result)) {
       echo "data.setCell(".$i.",0,'".$record['host']."');";
       echo "data.setCell(".$i.",1,".$record['curr'].");";
       echo "data.setCell(".$i.",2,".$record['tot'].");\n";
       $i=$i+1;
       }
}
?>
        var table = new google.visualization.Table(document.getElementById('queryHosts'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>
<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'User Connections');
        data.addColumn('number', 'Current');
        data.addColumn('number', 'Total');
        data.addRows(50);
<?php
$sql = "select user, current_connections curr, total_connections tot
 from performance_schema.users
 order by curr desc, tot desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['user']."');";
   echo "data.setCell(".$i.",1,".$record['curr'].");";
   echo "data.setCell(".$i.",2,".$record['tot'].");\n";
   $i=$i+1;
   }
}
?>
        var table = new google.visualization.Table(document.getElementById('queryUsers'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>
<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Host Cache');
        data.addColumn('string', 'IP address');
        data.addColumn('string', 'First access');
        data.addColumn('string', 'Last access');
        data.addColumn('number', 'Errors');
        data.addColumn('string', 'First error');
        data.addColumn('string', 'Last error');
        data.addRows(50);
<?php
$sql = "select ip, host, SUM_CONNECT_ERRORS err, FIRST_SEEN first, LAST_SEEN last,
   FIRST_ERROR_SEEN firste, LAST_ERROR_SEEN laste
 from performance_schema.host_cache
 order by last_seen desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['host']."');";
   echo "data.setCell(".$i.",1,'".$record['ip']."');";
   echo "data.setCell(".$i.",2,'".$record['first']."');";
   echo "data.setCell(".$i.",3,'".$record['last']."');";
   echo "data.setCell(".$i.",4,".$record['err'].");";
   echo "data.setCell(".$i.",5,'".$record['firste']."');";
   echo "data.setCell(".$i.",6,'".$record['laste']."');\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('queryHostCache'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('number', 'ID');
        data.addColumn('string', 'User');
        data.addColumn('string', 'State');
        data.addColumn('string', 'Query');
        data.addColumn('number', 'BlockTxID');
        data.addColumn('string', 'BlockQuery');
        data.addRows(20);
<?php
$sql = "SELECT p.id, p.user, p.state,
       r.trx_query query, b.trx_id blocking_trx_id, b.trx_query blocking_query
 FROM  information_schema.processlist p, information_schema.innodb_lock_waits w,
       information_schema.innodb_trx b, information_schema.innodb_trx r
 WHERE b.trx_id = w.blocking_trx_id 
   AND r.trx_id = w.requesting_trx_id
   AND p.id=r.trx_mysqli_thread_id LIMIT 20";
$result = mysqli_query($cnn, $sql);
if($result) {
 $i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,".$record['id'].");";
   echo "data.setCell(".$i.",1,'".$record['user']."');";
   echo "data.setCell(".$i.",2,'".$record['state']."');";
   echo "data.setCell(".$i.",4,".$record['blocking_trx_id'].");";
   echo "data.setCell(".$i.",3,'".str_replace("\n"," ",addslashes(substr($record['query'],0,64)))."');";
   echo "data.setCell(".$i.",5,'".str_replace("\n"," ",addslashes(substr($record['blocking_query'],0,64)))."');\n";
   $i=$i+1;
   }
  }
?>
        var table = new google.visualization.Table(document.getElementById('queryBlockLock'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Table Locks'); data.addColumn('string', 'DB');
        data.addColumn('number', 'In use');
        data.addColumn('number', 'Name locked');
        data.addRows(20);
<?php
$sql = "show open tables WHERE In_use>0";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",1,'".$record['Database']."');";
   echo "data.setCell(".$i.",0,'".$record['Table']."');";
   echo "data.setCell(".$i.",2,".$record['In_use'].");";
   echo "data.setCell(".$i.",3,".$record['Name_locked'].");\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('queryLockTable'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Object'); data.addColumn('string', 'DB');
        data.addColumn('string', 'Type');
        data.addColumn('string', 'Status');
        data.addColumn('string', 'Duration');
        data.addRows(100);
<?php
$sql = "select * from performance_schema.metadata_locks order by LOCK_DURATION desc LIMIT 100";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",1,'".$record['OBJECT_SCHEMA']."');";
   echo "data.setCell(".$i.",0,'".$record['OBJECT_NAME']."');";
   echo "data.setCell(".$i.",2,'".$record['LOCK_TYPE']."');";
   echo "data.setCell(".$i.",3,'".$record['LOCK_STATUS']."');";
   echo "data.setCell(".$i.",4,'".$record['LOCK_DURATION']."');\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('queryLOCK57'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>
<!--
In MariaDB:
select THREAD_ID, LOCK_MODE, LOCK_DURATION, LOCK_TYPE, TABLE_SCHEMA, TABLE_NAME from information_schema.METADATA_LOCK_INFO;
-->

</head>

<body>
<?php
echo '<a class="button" href="my2dash.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Dashboard&nbsp;</a>&nbsp;';
echo '<a class="nobutton" href="my2curr.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Status&nbsp;</a>&nbsp;';
echo '<a class="button" href="my2stat.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Performance&nbsp;</a>&nbsp;';
echo '<a class="button" href="my2cust.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Statistics&nbsp;</a>&nbsp;';
?>
</div>
<h3>Sessions</h3>
<div id="queryProcessList"></div>
<p>
<h3>Clients</h3>
<p>
<table><tr><td><div id="queryHostCache"></div><td>&nbsp;<td><div id="queryHosts"></div><td>&nbsp;<td><div id="queryUsers"></div></table>
<p>

<table>
<tr><td>
  <h3>InnoDB Blocking Locks</h3>
  <p>
  <div id="queryBlockLock"></div>
<td>
  <h3>Table Locks</h3>
  <p>
  <div id="queryLockTable"></div>
<td>
  <h3>Metadata Locks</h3>
  <p>
  <div id="queryLOCK57"></div>
</table>

<?php
$sql="show slave status";
$result = @mysqli_query($cnn, $sql);
$record = @mysqli_fetch_array($result);
if ( ! empty ($record) ) {
    echo "<h3>Replication - Slave Status</h3><p>&nbsp;";
    echo " I/O Thread: <b>". $record['Slave_IO_Running']."</b>";
    echo " SQL Thread: <b>". $record['Slave_SQL_Running']."</b>";
    echo " Delay: <b>". $record['Seconds_Behind_Master']."</b>";
    if ( array_key_exists('Executed_Gtid_Set', $record) ) {
        echo "<br>&nbsp; Retrieved GTID: ". $record['Retrieved_Gtid_Set'];
        echo "&nbsp; Executed GTID: ". $record['Executed_Gtid_Set']; }
}

$sql="SELECT MEMBER_HOST, MEMBER_PORT, MEMBER_ID, MEMBER_STATE FROM performance_schema.replication_group_members";
$result = @mysqli_query($cnn, $sql);
if($result) {
  echo '<h3>Group Replication - Members Status</h3>';
  echo '<table class="google-visualization-table-table" cellspacing="0">';
  echo '<tr class="google-visualization-table-tr-head">';
  echo '<th class="google-visualization-table-th gradient unsorted">&nbsp;';
  echo '<th class="google-visualization-table-th gradient unsorted">Host';
  echo '<th class="google-visualization-table-th gradient unsorted">Port';
  echo '<th class="google-visualization-table-th gradient unsorted">ID';
  echo '<th class="google-visualization-table-th gradient unsorted">State';
  $i=1; while ($record = mysqli_fetch_array($result)) {
    echo '<tr class="google-visualization-table-tr-even">';
    echo '<td class="google-visualization-table-td google-visualization-table-seq">'.$i;
    echo '<td class="google-visualization-table-td">'.$record['MEMBER_HOST'];
    echo '<td class="google-visualization-table-td google-visualization-table-td-number">'.$record['MEMBER_PORT'];
    echo '<td class="google-visualization-table-td google-visualization-table-td-number">'.$record['MEMBER_ID'];
    echo '<td class="google-visualization-table-td">'.$record['MEMBER_STATE']."\n";
    $i=$i+1;
    }
  echo '</table>';
 }

$sql="show master status";
$result = @mysqli_query($cnn, $sql);
$record = @mysqli_fetch_array($result);
if ( ! empty ($record) ) {
    echo "<h3>Replication - Master Status</h3><p>&nbsp;";
    echo " Binlog file: ". $record['File'];
    echo " Position: ". $record['Position'];
    if ( array_key_exists('Executed_Gtid_Set', $record) ) {
        echo "<br>&nbsp; Executed GTID: ". $record['Executed_Gtid_Set']; }
}
?>

<p>
<!--
SELECT MEMBER_ID, TRANSACTIONS_COMMITTED_ALL_MEMBERS,
  COUNT_TRANSACTIONS_CHECKED, COUNT_CONFLICTS_DETECTED, COUNT_TRANSACTIONS_IN_QUEUE, COUNT_TRANSACTIONS_ROWS_VALIDATING
  FROM performance_schema.replication_group_member_stats;
-->


<?php
if(isset($my2conn["conn"][$my2c])) {
    echo "Connection: <b>" . $my2conn["conn"][$my2c] . "</b>";
    echo "<br>Host: " . $my2conn["host"][$my2c];
}

$sql="select version() ver";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo "<br>Version: ".$record['ver'];
$sql="select date_format(date_sub(now(), INTERVAL variable_value second),'%Y-%m-%d %T') sta, now() dat from information_schema.global_status where variable_name='UPTIME'";
if (substr($record['ver'],0,3)=='5.7') {
    $sql="select date_format(date_sub(now(), INTERVAL variable_value second),'%Y-%m-%d %T') sta, now() dat from performance_schema.global_status where variable_name='UPTIME'";
}
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo "<br>Started: ".$record['sta'];
echo "<br>Date: ".$record['dat'];
?>
<p>
<form method="get" action="my2curr.php" name="login_form">
Choose Connection:
<select name="my2Conn" id="sel_server">
<?php
for ($i=1; $i<=count($my2conn["conn"]); $i++)
    echo ' <option value="' .$i. '" >' .$my2conn["conn"][$i]."</option>\n";
?>
</select>
<input value="Change" type="submit">
<input type="hidden" name="target" value="my2curr.php">
</form>

My2 <img src="my2s.png" alt="my2 Logo">
v.0.0.7 (Beta) - Copyright &copy; 2014-2018 by <a href="mailto:mail@meo.bogliolo.name">meo</a>
<hr>
<p >
<b>My2</b> displays useful performance charts for MySQL.
See the <a href="faq.htm" onclick="javascript:void window.open('faq.htm','win_name','width=820,height=700,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=600,top=0');return false;">FAQ</a> 
for more information.
</body>
</html>
