<?php
error_reporting(E_ALL ^ E_DEPRECATED ^ E_WARNING);
?>
<html>
  <head>
    <title>My2 - Statistics</title>
    <link rel="stylesheet" href="gc.css" />
    <link rel="icon" href="DBguru.png" />
    <script type="text/javascript" src="https://www.google.com/jsapi"></script>

<?php date_default_timezone_set('UTC'); echo '<!-- Time (UTC): '. date('Y-m-d G:i:s.u') ." -->\n";
if ( ! file_exists('config.inc.php')) {
    echo '<h1>Configuration file missing</h1>';
    echo '<p>Please create <b>config.inc.php</b> configuration file';
    echo '<p>See the <b><a href="faq.htm#Con_00">online documentation</a></b> for more information.';
    exit;
}
include 'common.php';
if (isset($_GET['my2Conn']))
     $_SESSION['my2Conn'] = $_GET['my2Conn'];
else $_SESSION['my2Conn'] = 1;
$my2c = $_SESSION['my2Conn'];
?>

<script type='text/javascript'>
      google.load('visualization', '1.0', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Event');
        data.addColumn('number', 'Count');
        data.addColumn('number', 'SumTimerWait');
        data.addColumn('string', 'HumanTimer');
        data.addRows(50);
<?php
$cnn = mysqli_connect($my2conn["host"][$my2c], $my2conn["user"][$my2c], $my2conn["pass"][$my2c]);
$sql="select version() ver";
$result = mysqli_query($cnn, $sql);
$v = mysqli_fetch_array($result);
$glob="information_schema.";
if (substr($v['ver'],0,3)=='5.7') {
    $glob="performance_schema."; 
}

$sql = "select EVENT_NAME,COUNT_STAR,round(SUM_TIMER_WAIT/1000000) SUM_TIMER_WAIT, SEC_TO_TIME(SUM_TIMER_WAIT/1000000000000) HU from performance_schema.events_statements_summary_global_by_event_name order by SUM_TIMER_WAIT desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['EVENT_NAME']."');";
   echo "data.setCell(".$i.",1,".$record['COUNT_STAR'].");";
   echo "data.setCell(".$i.",2,".$record['SUM_TIMER_WAIT'].");\n";
   echo "data.setCell(".$i.",3,'".$record['HU']."');\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('query1'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Event');
        data.addColumn('number', 'Count');
        data.addColumn('number', 'SumTimerWait');
        data.addRows(50);
<?php
$sql = "select EVENT_NAME,COUNT_STAR,round(SUM_TIMER_WAIT/1000000) SUM_TIMER_WAIT from performance_schema.events_waits_summary_global_by_event_name where event_name!='idle' order by SUM_TIMER_WAIT desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['EVENT_NAME']."');";
   echo "data.setCell(".$i.",1,".$record['COUNT_STAR'].");";
   echo "data.setCell(".$i.",2,".$record['SUM_TIMER_WAIT'].");";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('query3'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Event');
        data.addColumn('number', 'Count');
        data.addColumn('number', 'SumTimerWait');
        data.addRows(50);
<?php
$sql = "select EVENT_NAME,COUNT_STAR,round(SUM_TIMER_WAIT/1000000) SUM_TIMER_WAIT from performance_schema.file_summary_by_event_name order by SUM_TIMER_WAIT desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['EVENT_NAME']."');";
   echo "data.setCell(".$i.",1,".$record['COUNT_STAR'].");";
   echo "data.setCell(".$i.",2,".$record['SUM_TIMER_WAIT'].");\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('query2'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'File');
        data.addColumn('string', 'Event');
        data.addColumn('number', 'Count');
        data.addColumn('number', 'SumTimerWait');
        data.addColumn('number', 'Read Count');
        data.addColumn('number', 'Read Timer');
        data.addColumn('number', 'Read Bytes');
        data.addColumn('number', 'Write Count');
        data.addColumn('number', 'Write Timer');
        data.addColumn('number', 'Write Bytes');
        data.addRows(50);
<?php
$sql = "select 
 FILE_NAME,EVENT_NAME,COUNT_STAR,SUM_TIMER_WAIT,
 COUNT_READ,SUM_TIMER_READ,SUM_NUMBER_OF_BYTES_READ,
 COUNT_WRITE,SUM_TIMER_WRITE,SUM_NUMBER_OF_BYTES_WRITE
from performance_schema.file_summary_by_instance order by SUM_TIMER_WAIT desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['FILE_NAME']."');";
   echo "data.setCell(".$i.",1,'".$record['EVENT_NAME']."');";
   echo "data.setCell(".$i.",2,".$record['COUNT_STAR'].");";
   echo "data.setCell(".$i.",3,".$record['SUM_TIMER_WAIT'].");";
   echo "data.setCell(".$i.",4,".$record['COUNT_READ'].");";
   echo "data.setCell(".$i.",5,".$record['SUM_TIMER_READ'].");";
   echo "data.setCell(".$i.",6,".$record['SUM_NUMBER_OF_BYTES_READ'].");";
   echo "data.setCell(".$i.",7,".$record['COUNT_WRITE'].");";
   echo "data.setCell(".$i.",8,".$record['SUM_TIMER_WRITE'].");";
   echo "data.setCell(".$i.",9,".$record['SUM_NUMBER_OF_BYTES_WRITE'].");\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('query5'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
      google.load('visualization', '1', {packages:['table']});
      google.setOnLoadCallback(drawTable);
      function drawTable() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Schema');
        data.addColumn('string', 'Digest Text');
        data.addColumn('number', 'Count');
        data.addColumn('number', 'SumTimerWait');
        data.addColumn('string', 'HumanTimer');
        data.addColumn('number', 'Average (sec.)');
        data.addColumn('number', 'Rows Affected');
        data.addColumn('number', 'Rows Sent');
        data.addColumn('number', 'Rows Examined');
        data.addColumn('number', 'Disk TMP Tables');
        data.addColumn('number', 'TMP Tables');
        data.addColumn('number', 'Sort Merge');
        data.addColumn('number', 'No Index');
        data.addColumn('number', 'No Good Index');
        data.addRows(50);
<?php
$sql = "select SCHEMA_NAME,DIGEST_TEXT,COUNT_STAR,SUM_TIMER_WAIT, SEC_TO_TIME(SUM_TIMER_WAIT/1000000000000) HU,
 round(AVG_TIMER_WAIT/1000000000000,3) AVG_TIMER_WAIT, SUM_ROWS_AFFECTED,SUM_ROWS_SENT,SUM_ROWS_EXAMINED,
 SUM_CREATED_TMP_DISK_TABLES,SUM_CREATED_TMP_TABLES,SUM_SORT_MERGE_PASSES, 
 SUM_NO_INDEX_USED,SUM_NO_GOOD_INDEX_USED
from performance_schema.events_statements_summary_by_digest order by SUM_TIMER_WAIT desc limit 50";
$result = mysqli_query($cnn, $sql);
if($result) {
$i=0; while ($record = mysqli_fetch_array($result)) {
   echo "data.setCell(".$i.",0,'".$record['SCHEMA_NAME']."');";
   echo "data.setCell(".$i.",1,'".$record['DIGEST_TEXT']."');";
   echo "data.setCell(".$i.",2,".$record['COUNT_STAR'].");";
   echo "data.setCell(".$i.",3,".$record['SUM_TIMER_WAIT'].");";
   echo "data.setCell(".$i.",4,'".$record['HU']."');";
   echo "data.setCell(".$i.",5,".$record['AVG_TIMER_WAIT'].");";
   echo "data.setCell(".$i.",6,".$record['SUM_ROWS_AFFECTED'].");";
   echo "data.setCell(".$i.",7,".$record['SUM_ROWS_SENT'].");";
   echo "data.setCell(".$i.",8,".$record['SUM_ROWS_EXAMINED'].");";
   echo "data.setCell(".$i.",9,".$record['SUM_CREATED_TMP_DISK_TABLES'].");";
   echo "data.setCell(".$i.",10,".$record['SUM_CREATED_TMP_TABLES'].");";
   echo "data.setCell(".$i.",11,".$record['SUM_SORT_MERGE_PASSES'].");";
   echo "data.setCell(".$i.",12,".$record['SUM_NO_INDEX_USED'].");";
   echo "data.setCell(".$i.",13,".$record['SUM_NO_GOOD_INDEX_USED'].");\n";
   $i=$i+1;
   }
   }
?>
        var table = new google.visualization.Table(document.getElementById('query4'));
        table.draw(data, {showRowNumber: true, allowHtml: true, pageSize: 5, page: 'enable'});
      }
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
$sql="SELECT 'Sessions' kpi, count(*) val from information_schema.processlist";
$result = mysqli_query($cnn, $sql);
if($result) {
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
}
?>
]);
var options = {
  width: 150, height: 150, min: 0,
  minorTicks: 5,
  greenFrom:0, greenTo: 50,
  yellowFrom:50, yellowTo: 100,
  redFrom: 100, 
<?php
$sql = "SELECT variable_value val, round(variable_value/2) val2 from ".$glob."global_variables where variable_name='MAX_CONNECTIONS'";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo "max: ".$record['val'].", redTo: ".$record['val'].", yellowTo: ".$record['val2'].", redFrom: ".$record['val2'];
?>
};
var chart = new google.visualization.Gauge(document.getElementById('gau01'));
chart.draw(data, options);
}
</script>

<script type="text/javascript">
      google.load("visualization", "1", {packages:["corechart"]});
      google.setOnLoadCallback(drawChart);
      function drawChart() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Date');
<?php
$my2q=8;
if(isset($my2stat["des1"][$my2q]))
    echo "data.addColumn('number', '". $my2stat["des1"][$my2q] ."');";
if(isset($my2stat["des2"][$my2q]))
    echo "data.addColumn('number', '". $my2stat["des2"][$my2q] ."');";
if(isset($my2stat["des3"][$my2q]))
    echo "data.addColumn('number', '". $my2stat["des3"][$my2q] ."');";
if(isset($my2stat["des4"][$my2q]))
    echo "data.addColumn('number', '". $my2stat["des4"][$my2q] ."');\n";
?>
        data.addRows([
<?php
$sql= "select sum(if(variable_name='".  (isset($my2stat["val1"][$my2q])?$my2stat["val1"][$my2q]:"")."',variable_value,0)) val1 ".
      ",sum(if(variable_name='".  (isset($my2stat["val2"][$my2q])?$my2stat["val2"][$my2q]:"") ."',variable_value,0)) val2 ".
      ",sum(if(variable_name='".  (isset($my2stat["val3"][$my2q])?$my2stat["val3"][$my2q]:"") ."',variable_value,0)) val3 ".
      ",sum(if(variable_name='".  (isset($my2stat["val4"][$my2q])?$my2stat["val4"][$my2q]:"") ."',variable_value,0)) val4 ".
      "from my2.status ".
      "where variable_name in ('".  (isset($my2stat["val1"][$my2q])?$my2stat["val1"][$my2q]:"")  ."','".
       (isset($my2stat["val2"][$my2q])?$my2stat["val2"][$my2q]:"") ."','".
        (isset($my2stat["val3"][$my2q])?$my2stat["val3"][$my2q]:"")."','".
         (isset($my2stat["val4"][$my2q])?$my2stat["val4"][$my2q]:"") ."') ".
      "and timest >= date_sub(now(), INTERVAL 1 HOUR) group by timest";
$result = mysqli_query($cnn, $sql);
$first=1;
while ($record = mysqli_fetch_array($result)) {
   if ($first==1) {$first=0; $x1=$record['val1']+0; $x2=$record['val2']+0; $x3=$record['val3']+0; $x4=$record['val4']+0;} 
   $tmp1=$record['val1']+0; $tmp2=$record['val2']+0; $tmp3=$record['val3']+0; $tmp4=$record['val4']+0;
   }
echo "['Op./sec.', ";
if(isset($tmp1))
    echo ($tmp1-$x1)/3600; echo ", ";
if(isset($tmp2))
    echo ($tmp2-$x2)/3600; echo ", ";
if(isset($tmp3))
    echo ($tmp3-$x3)/3600; echo ", ";
if(isset($tmp4))
    echo ($tmp4-$x4)/3600;
echo "]]);var options = { title: '" . $my2stat["titl"][$my2q] ."', width: 160, height: 160, isStacked: true, legend: { position: 'none' }, };";
?>
        var chart = new google.visualization.ColumnChart(document.getElementById('bar01'));
        chart.draw(data, options);
      }
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
$sql = "SELECT 'Key Hit' kpi, round((1-(g1.variable_value/g2.variable_value))*100,2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
        "where g1.variable_name='KEY_READS' and g2.variable_name='KEY_READ_REQUESTS'";
$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
?>
]);
var options = {
  width: 120, height: 120, min: 90,
  redFrom: 0, redTo: 95, yellowFrom:95, yellowTo: 99,
  greenFrom:99, greenTo: 100, minorTicks: 5
};
var chart = new google.visualization.Gauge(document.getElementById('gau02'));
chart.draw(data, options);
}
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
$sql = "SELECT 'Write Hit' kpi, round((1-(g1.variable_value/g2.variable_value))*100,2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
        "where g1.variable_name='KEY_WRITES' and g2.variable_name='KEY_WRITE_REQUESTS'";
$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
?>
]);
var options = {
  width: 120, height: 120, min: 80,
  redFrom: 0, redTo: 90, yellowFrom:90, yellowTo: 99,
  greenFrom:99, greenTo: 100, minorTicks: 5
};
var chart = new google.visualization.Gauge(document.getElementById('gau03'));
chart.draw(data, options);
}
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
$sql = "SELECT 'InnoDB Hit' kpi, round((1-(g1.variable_value/g2.variable_value))*100,2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
        "where g1.variable_name='INNODB_BUFFER_POOL_READS' and g2.variable_name='INNODB_BUFFER_POOL_READ_REQUESTS'";
$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
?>
]);
var options = {
  width: 120, height: 120, min: 90,
  redFrom: 0, redTo: 95, yellowFrom:95, yellowTo: 99,
  greenFrom:99, greenTo: 100, minorTicks: 5
};
var chart = new google.visualization.Gauge(document.getElementById('gau04'));
chart.draw(data, options);
}
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
# innodb_log_waits innodb_log_writes
$sql = "SELECT 'Log' kpi, round((1-(g1.variable_value/g2.variable_value))*100,2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
        "where g1.variable_name='INNODB_LOG_WRITES' and g2.variable_name='INNODB_LOG_WRITE_REQUESTS'";
$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
?>
]);
var options = {
  width: 120, height: 120, min: 80,
  redFrom: 0, redTo: 90, yellowFrom:90, yellowTo: 99,
  greenFrom:99, greenTo: 100, minorTicks: 5
};
var chart = new google.visualization.Gauge(document.getElementById('gau05'));
chart.draw(data, options);
}
</script>

<script type='text/javascript'>
google.load('visualization', '1', {packages:['gauge']});
google.setOnLoadCallback(drawChart);
function drawChart() {
var data = new google.visualization.DataTable();
data.addColumn('string', 'Label');
data.addColumn('number', 'Value');
data.addRows([
<?php
$sql="select version() ver";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
if (substr($record['ver'],0,3)=='5.7')
    $sql = "SELECT 'QCache' kpi, round(((g1.variable_value/(g1.variable_value+g2.COUNT_STAR)))*100,2) val from performance_schema.global_status g1, ".
        $glob."events_statements_summary_global_by_event_name g2 ".
        "where g1.variable_name='QCACHE_HITS' and g2.event_name='statement/sql/select'";
else
    $sql = "SELECT 'QCache' kpi, round(((g1.variable_value/(g1.variable_value+g2.variable_value)))*100,2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
        "where g1.variable_name='QCACHE_HITS' and g2.variable_name='COM_SELECT'";
$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
echo "['".$record['kpi'] . "', " . $record['val'] . "]\n";
}
?>
]);
var options = {
  width: 120, height: 120, min: 0,
  redFrom: 0, redTo: 30, yellowFrom:30, yellowTo: 60,
  greenFrom: 60, greenTo: 100, minorTicks: 10
};
var chart = new google.visualization.Gauge(document.getElementById('gau06'));
chart.draw(data, options);
}
</script>

<script type="text/javascript">
      google.load("visualization", "1", {packages:["corechart"]});
      google.setOnLoadCallback(drawChart);
      function drawChart() {
        var data = new google.visualization.DataTable();
        data.addColumn('string', 'Type');
        data.addColumn('number', 'Count');
        data.addRows([
<?php
$sql="select version() ver";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
if (substr($record['ver'],0,3)=='5.7')
    $sql = "SELECT 'SELECT' kpi, round((g1.COUNT_STAR/g2.variable_value),2) val from ".$glob."events_statements_summary_global_by_event_name g1, ".$glob."global_status g2 ".
         "where g1.event_name='statement/sql/select' and g2.variable_name='UPTIME'". 
        "UNION SELECT 'DELETE' kpi, round((g1.COUNT_STAR/g2.variable_value),2) val from ".$glob."events_statements_summary_global_by_event_name g1, ".$glob."global_status g2 ".
         "where g1.event_name='statement/sql/delete' and g2.variable_name='UPTIME'".
        "UNION SELECT 'UPDATE' kpi, round((g1.COUNT_STAR/g2.variable_value),2) val from ".$glob."events_statements_summary_global_by_event_name g1, ".$glob."global_status g2 ".
         "where g1.event_name='statement/sql/update' and g2.variable_name='UPTIME'".
        "UNION SELECT 'INSERT' kpi, round((g1.COUNT_STAR/g2.variable_value),2) val from ".$glob."events_statements_summary_global_by_event_name g1, ".$glob."global_status g2 ".
         "where g1.event_name='statement/sql/insert' and g2.variable_name='UPTIME'";
else
    $sql = "SELECT 'SELECT' kpi, round((g1.variable_value/g2.variable_value),2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
         "where g1.variable_name='COM_SELECT' and g2.variable_name='UPTIME'". 
        "UNION SELECT 'DELETE' kpi, round((g1.variable_value/g2.variable_value),2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
         "where g1.variable_name='COM_DELETE' and g2.variable_name='UPTIME'".
        "UNION SELECT 'UPDATE' kpi, round((g1.variable_value/g2.variable_value),2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
         "where g1.variable_name='COM_UPDATE' and g2.variable_name='UPTIME'".
        "UNION SELECT 'INSERT' kpi, round((g1.variable_value/g2.variable_value),2) val from ".$glob."global_status g1, ".$glob."global_status g2 ".
         "where g1.variable_name='COM_INSERT' and g2.variable_name='UPTIME'";

$result = mysqli_query($cnn, $sql);
while ($record = mysqli_fetch_array($result)) {
   echo "['". $record['kpi'] . "', " . $record['val'] . "],\n"; }
echo "['Other', 0]";
?>
        ]);
        var options = {
          title: 'Statements /sec.',
          width: 320, height: 180,
          pieSliceText: 'value',
          is3D: true
        };
        var chart = new google.visualization.PieChart(document.getElementById('pie1'));
        chart.draw(data, options);
      }
</script>

</head>

<body>
<?php
echo '<a class="button" href="my2dash.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Dashboard&nbsp;</a>&nbsp;';
echo '<a class="button" href="my2curr.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Status&nbsp;</a>&nbsp;';
echo '<a class="nobutton" href="my2stat.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Performance&nbsp;</a>&nbsp;';
echo '<a class="button" href="my2cust.php?my2Conn='.$_SESSION['my2Conn'].'">&nbsp;Statistics&nbsp;</a>&nbsp;';
?>
</div>

<table border=0>
<tr >
    <td><table><tr><td><b>CPU Usage</b><tr><td><span style="font-family:'digital-clock-font'; font-size:600%; color: red">

<?php
$sql="select format((sum(SUM_TIMER_WAIT)/1000000000000)/variable_value,2) dbcpu".
     " from ".$glob."global_status, performance_schema.events_statements_summary_global_by_event_name".
     " where variable_name='UPTIME' group by variable_value";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo $record['dbcpu'];
?>
    </table>
<?php
echo ' <td><a href="my2cust.php?my2Stat=2&my2Conn=' .$_SESSION['my2Conn'].'"><div id="pie1"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=1&my2Conn=' .$_SESSION['my2Conn'].'"><div id="gau01"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=9&my2Conn='.$_SESSION['my2Conn'].'"><div id="gau02"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=21&my2Conn='.$_SESSION['my2Conn'].'"><div id="gau03"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=10&my2Conn='.$_SESSION['my2Conn'].'"><div id="gau04"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=22&my2Conn='.$_SESSION['my2Conn'].'"><div id="gau05"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=8&my2Conn='.$_SESSION['my2Conn'].'"><div id="gau06"></div></a>';
echo ' <td><a href="my2cust.php?my2Stat=8&my2Conn=' .$_SESSION['my2Conn'].'"><div id="bar01"></div></a>';
?>
</table>

<table border=0>
<tr >
 <td>
    <h3>Top SQL</h3>
    <div id="query4"></div>
</table>
<p>
<table border=0>
<tr >
 <td>
    <h3>Statement Events</h3>
    <div id="query1"></div>
 <td>
    <h3>I/O Events</h3>
    <div id="query2"></div>
 <td>
    <h3>Wait Events</h3>
    <div id="query3"></div>
</table>
<p>
<table border=0>
<tr >
 <td>
    <h3>Top I/O</h3>
    <div id="query5"></div>
</table>
<p>

<?php
if(isset($my2conn["conn"][$my2c])) {
    echo "Connection: <b>" . $my2conn["conn"][$my2c] . "</b>";
    echo "<br>Host: " . $my2conn["host"][$my2c];
}

$sql="select version() ver";
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo "<br>Version: ".$record['ver'];
$sql="select date_format(date_sub(now(), INTERVAL variable_value second),'%Y-%m-%d %T') sta, now() dat from information_schema.global_status where variable_name='UPTIME'";
if (substr($record['ver'],0,3)=='5.7') {
    $sql="select date_format(date_sub(now(), INTERVAL variable_value second),'%Y-%m-%d %T') sta, now() dat from performance_schema.global_status where variable_name='UPTIME'";
}
$result = mysqli_query($cnn, $sql);
$record = mysqli_fetch_array($result);
echo "<br>Started: ".$record['sta'];
echo "<br>Date: ".$record['dat'];
?>
<p>
<form method="get" action="my2stat.php" name="login_form">
Choose Connection:
<select name="my2Conn" id="sel_server">
<?php
for ($i=1; $i<=count($my2conn["conn"]); $i++)
    echo ' <option value="' .$i. '" >' .$my2conn["conn"][$i]."</option>\n";
?>
</select>
<input value="Change" type="submit">
<input type="hidden" name="target" value="my2stat.php">
</form>

My2 <img src="my2s.png" alt="my2 Logo">
v.0.0.7 (Beta) - Copyright &copy; 2014-2018 by <a href="mailto:mail@meo.bogliolo.name">meo</a>
<hr>
<p >
<b>My2</b> displays useful performance charts for MySQL.
See the <a href="faq.htm" onclick="javascript:void window.open('faq.htm','win_name','width=820,height=700,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=600,top=0');return false;">FAQ</a> 
for more information.
</body>
</html>

